SystemOrganization addCategory: #'MonticelloFileDirectory-Base'!
SystemOrganization addCategory: #'MonticelloFileDirectory-Test'!

MCVersionInfoWriter subclass: #MCFileDirectoryVersionInfoWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Base'!

!MCFileDirectoryVersionInfoWriter methodsFor: 'as yet unclassified' stamp: 'MU 11/23/2007 15:15'!
writeFileForVersionInfo: aVersionInfo

	self stream: (FileStream forceNewFileNamed: aVersionInfo name).
	self writeVersionInfo: aVersionInfo.
	self stream close.! !

Object subclass: #McFdCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Base'!

!McFdCreator methodsFor: 'creation' stamp: 'pe 11/26/2007 09:22'!
createAllForVersion: aVersion at: aDirectory
"calls createDirectoryForPackage: at: , createDirectoryForVersion: at:  and createSubDirectoryForClassCategoriesForPackage: at:"

	| dirString |
	self createDirectoryForPackage: (aVersion package) at: aDirectory.
	dirString := aDirectory fullName, FileDirectory slash asSymbol, (aVersion package) name.
	dirString := FileDirectory on: dirString.
	self createDirectoryForVersion: aVersion at:dirString.
	
	dirString := dirString fullName, FileDirectory slash asSymbol, aVersion info name.
	dirString := FileDirectory on: dirString. 
	
	self createSubDirectoryForClassCategoriesForPackage: (aVersion package) at: dirString.
	self createFilesFrom: aVersion at: dirString.
! !

!McFdCreator methodsFor: 'creation' stamp: 'MU 11/21/2007 14:48'!
createDirectoryForPackage: aPackage at: aDirectory 
	aDirectory createDirectory: aPackage name! !

!McFdCreator methodsFor: 'creation' stamp: 'pe 11/26/2007 09:22'!
createDirectoryForVersion: aVersion at: aDirectory
	aDirectory createDirectory: aVersion info name.! !

!McFdCreator methodsFor: 'creation' stamp: 'pe 11/26/2007 10:01'!
createFilesFrom: aVersion at: aDirectory
"puts test.txt in every subdirectory for testing"	
	| classCategory directory streamForVersionInfo streamForDependencies stream aMCVersionInfoWriter |

		streamForVersionInfo := aDirectory forceNewFileNamed: 'VersionInfo.txt'.
		streamForVersionInfo nextPutAll: (aVersion info)summaryHeader.
		streamForVersionInfo close.
		
		streamForDependencies := aDirectory forceNewFileNamed: 'Dependencies.txt'.
		streamForDependencies nextPutAll: aVersion dependencies..
		streamForDependencies close.

	(aVersion package) packageInfo systemCategories do: [:each |
		classCategory := (self extractCategoryStringFrom: each asString).
		directory := aDirectory fullName, FileDirectory slash asSymbol, classCategory.
		directory := FileDirectory on: directory.
		
		stream := directory forceNewFileNamed: 'class.txt'.
		stream nextPutAll: (aVersion package snapshot definitions at:4)source.
"		aMCVersionInfoWriter := MCVersionInfoWriter on: stream.
		aMCVersionInfoWriter writeVersionInfo: aVersion info."
		stream close.
		] ! !

!McFdCreator methodsFor: 'creation' stamp: 'MU 11/23/2007 11:27'!
createSubDirectoryForClassCategoriesForPackage: aPackage at: aDirectory
	
	aPackage packageInfo systemCategories do: [:each | 
		aDirectory createDirectory: (self extractCategoryStringFrom: each asString) ]! !

!McFdCreator methodsFor: 'creation' stamp: 'MU 11/21/2007 17:15'!
extractCategoryStringFrom: aString 
	^ (aString subStrings: '-') second.
! !

MCWriter subclass: #MCFileDirectoryWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Base'!

!MCFileDirectoryWriter methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 12:33'!
writeVersion: aVersion! !

MCVersion subclass: #MCFileVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Base'!

!MCFileVersion class methodsFor: 'converting' stamp: 'pe 11/22/2007 11:46'!
fromVersion: aVersion
	^(self new)
		package: aVersion package;
		info: aVersion info;
		snapshot: aVersion snapshot;
		dependencies: aVersion dependencies.! !

!MCFileVersion class methodsFor: 'accessing' stamp: 'pe 11/22/2007 11:53'!
writerClass
	^MCFileDirectoryWriter! !

!MCFileVersion methodsFor: 'private-converting' stamp: 'pe 11/22/2007 11:51'!
dependencies: aDependencies
	dependencies := aDependencies! !

!MCFileVersion methodsFor: 'private-converting' stamp: 'pe 11/22/2007 11:51'!
info: aInfo
	info := aInfo! !

!MCFileVersion methodsFor: 'private-converting' stamp: 'pe 11/22/2007 11:52'!
package: aPackage
	package := aPackage! !

!MCFileVersion methodsFor: 'private-converting' stamp: 'pe 11/22/2007 11:52'!
snapshot: aSnapshot
	snapshot := aSnapshot! !

TestCase subclass: #McFdTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Test'!

McFdTestCase subclass: #McFdFilesystemTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Test'!

!McFdFilesystemTest methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 17:21'!
testCreateDirectory
	| dir creator aPackage |
	creator := McFdCreator new.
	dir := FileDirectory default.
	aPackage := MCPackage named: self packageName .
	
	[creator createDirectoryForPackage: aPackage at: dir.
	self assert: (dir directoryExists: aPackage name)] 
			ensure: [dir deleteDirectory: aPackage name]! !

!McFdFilesystemTest methodsFor: 'as yet unclassified' stamp: 'MU 11/23/2007 11:19'!
testCreateSubDirectory
	| dir creator aPackage |
	creator := McFdCreator new.
	dir := FileDirectory default.
	aPackage := MCPackage named: self packageName .
	
	[creator createSubDirectoryForClassCategoriesForPackage: aPackage at: dir .
	self assert: (dir directoryExists: self  subPackageName)
	] ensure: [(dir directoryNamed: self subPackageName ) recursiveDelete]! !

!McFdFilesystemTest methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 17:07'!
testExtractCategoryString
	| creator aString resultString |
	aString := 'Spaet-Abends'.
	creator := McFdCreator new.
	resultString := creator extractCategoryStringFrom: aString.
	self assert: 'Abends' = resultString.
	! !

McFdTestCase subclass: #McFdPackageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Test'!

!McFdPackageTest methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 13:16'!
testCreateMethod
	(Smalltalk at: #McFdFooBar) methodDictionary at: #m1 ifAbsent: [self fail] 
	! !

!McFdPackageTest methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 13:16'!
testCreatePackage
	Smalltalk at: #McFdFooBar ifAbsent: [self fail].
	
	! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 15:17'!
classCategoryName
	^ self packageName , '-' , self subPackageName! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 15:07'!
packageName
	^ 'McFdFooBar'! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 14:15'!
setUp
	Object 
		subclass: #McFdFooBar
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self classCategoryName.
	(Smalltalk at: #McFdFooBar) compile: 'm1 ^ 0'! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 15:17'!
subPackageName
	^ 'Base'! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 14:20'!
tearDown
	(Smalltalk at: #McFdFooBar) removeFromSystemUnlogged.
	
	Smalltalk organization removeCategory: self classCategoryName asSymbol! !

TestCase subclass: #McFdTestVersionInfoWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Test'!

!McFdTestVersionInfoWriter class methodsFor: 'as yet unclassified' stamp: ''!
testVersionInfoWriter
	| t1 t2 t3 t4 |
	self break.
	t2 := TextStream on: ''.
	t3 := MCVersionInfo
				name: 'Versionname'
				id: '123'
				message: 'message'
				date: Date today
				time: Time current
				author: 'wir'
				ancestors: #().
	t1 := MCVersionInfoWriter on: t2.
	t1 writeVersionInfo: t3.
	t4 := '(name ''Versionname'' message ''message'' id ''123'' date ''23 November 2007'' time ''1:55:31 pm'' author ''wir'' ancestors () stepChildren ())'.
	self assert: t2 contents = t4! !

!McFdTestVersionInfoWriter methodsFor: 'as yet unclassified' stamp: 'MU 11/23/2007 14:07'!
testVersionInfoWriter
	| versionInfoWriter aStream aVersionInfo expected |
	aStream := TextStream on: ''.
	aVersionInfo := MCVersionInfo name: 'Versionname' id: '123' message: 'message' date: Date today time: Time noon author: 'wir' ancestors: #().
	versionInfoWriter := MCFileDirectoryVersionInfoWriter on: aStream.
	versionInfoWriter writeVersionInfo: aVersionInfo.
	expected :=  '(name ''Versionname'' message ''message'' id ''123'' date ''23 November 2007'' time ''12:00 pm'' author ''wir'' ancestors () stepChildren ())'.
	self assert: (aStream contents = expected )! !

!McFdTestVersionInfoWriter methodsFor: 'as yet unclassified' stamp: 'MU 11/23/2007 15:06'!
testWriteVersionToFile
	| aStream aVersionInfoWriter expected aVersionInfo |
	[aVersionInfo := MCVersionInfo name: 'Versionname' id: '123' message: 'message' date: Date today time: Time noon author: 'wir' ancestors: #().
	aVersionInfoWriter := MCFileDirectoryVersionInfoWriter new.
	aVersionInfoWriter writeFileForVersionInfo: aVersionInfo.
	expected :=  '(name ''Versionname'' message ''message'' id ''123'' date ''23 November 2007'' time ''12:00 pm'' author ''wir'' ancestors () stepChildren ())'.
	self assert: (FileDirectory default fileExists: aVersionInfo name).
	aStream := FileStream fileNamed: aVersionInfo name.
	self assert: (aStream contents = expected).	
	aStream close.]
		ensure: [FileDirectory default deleteFileNamed: aVersionInfo name]
	! !
